# clauncher

**clauncher** is a simple Bash script designed to provide a convenient way to launch applications on Unix-like systems. It utilizes the fzf (fuzzy finder) tool to offer an interactive and efficient application launching experience.

This script is primarily designed for macOS, but it can be customized to support Linux or any other Unix system by modifying the appropriate parts of the script.

## Prerequisites

Before using **clauncher**, ensure that you have the following dependencies installed:

- [fzf](https://github.com/junegunn/fzf): A command-line fuzzy finder.

## Installation

1. Clone the repository to your local machine:

    ```bash
    git clone https://git.slc.ar/slococo/clauncher.git
    ```

2. Change into the project directory:

    ```bash
    cd clauncher
    ```

4. Install the script globally using:

    ```bash
    sudo make install
    ```

   This will move the `clauncher` script to `/usr/local/bin`, making it accessible system-wide.

5. To uninstall, use:

    ```bash
    sudo make uninstall
    ```

   This will remove the `clauncher` script from `/usr/local/bin`.

## Usage

### Basic Usage

Run the `clauncher` script in your terminal:

```bash
./clauncher
```

or if `/usr/local/bin` is in your `PATH` (it should be):

```bash
clauncher
```

This will present you with a list of applications to choose from using the fzf interface.

### Keyboard Shortcuts

- **Arrow Up/Down:** Navigate through the list.
- **Enter:** Launch the selected application.
- **Ctrl-C:** Exit the launcher without launching any application.

## Configuration

**clauncher** enhances its performance and retains your application launch history by generating a cache file (`$XDG_CACHE_HOME/launcher_opts`) and a history file (`$XDG_CACHE_HOME/launcher_opts_history`). These files adhere to the XDG standard directories, with fallback locations if the XDG variables are not set.

For customization, you can specify custom locations by creating a file named `.open_locations` in the `~/.config/clauncher` directory. List the custom locations, each on a new line. These custom locations will be included when updating the program list.

Additionally, if you want to ignore or add specific applications or commands, create two files inside `~/.config/clauncher`:

- `.open_ignore`: List the applications or commands to ignore, each on a new line.
- `.open_add`: List the additional applications or commands to include, each on a new line.

Edit these files directly to specify the applications or commands you want to exclude or include.

## License

This project is licensed under the MIT License.

## Contributions

Feel free to contribute, report issues, or suggest improvements!
